Search documentation of stdlib

# erl_anno (stdlib v8.0.2)

Copy Markdown View Source

Abstract datatype for the annotations of the Erlang Compiler.

This module provides an abstract type that is used by the Erlang Compiler and its helper modules for holding data such as column, line number, and text. The data type is a collection of annotations as described in the following.

The Erlang Token Scanner returns tokens with a subset of the following annotations, depending on the options:

- `column` - The column where the token begins.

- `location` - The line and column where the token begins, or just the line if the column is unknown.

- `text` - The token's text.

From this, the following annotation is derived:

- `line` - The line where the token begins.

This module also supports the following annotations, which are used by various modules:

- `file` - A filename.

- `generated` - A Boolean indicating if the abstract code is compiler-generated. The Erlang Compiler does not emit warnings for such code.

- `record` - A Boolean indicating if the origin of the abstract code is a record. Used by Dialyzer to assign types to tuple elements.

The functions `column()`, `end_location()`, `line()`, `location()`, and `text()` in the `erl_scan` module can be used for inspecting annotations in tokens.

The functions `anno_from_term()`, `anno_to_term()`, `fold_anno()`, `map_anno()`, `mapfold_anno()`, and `new_anno()`, in the `erl_parse` module can be used for manipulating annotations in abstract code.

### See Also

`erl_parse`, `erl_scan`

## Summary

### Types

anno()

A collection of annotations.

anno_term()

The term representing a collection of annotations. It is either a `location/0` or a list of key-value pairs.

column()
filename()
generated()
line()
location()
record_local()
text()

### Functions

column(Anno)

Returns the column of the annotations Anno.

end_location(Anno)

Returns the end location of the annotations Anno.

file(Anno)

Returns the filename of the annotations Anno. If there is no filename, `undefined` is returned.

from_term(Term)

Returns annotations with representation Term.

generated(Anno)

Returns `true` if annotations Anno is marked as generated. The default is to return `false`.

is_anno(Term)

Returns `true` if Term is a collection of annotations, otherwise `false`.

line(Anno)

Returns the line of the annotations Anno.

location(Anno)

Returns the location of the annotations Anno. If there is no location, a zero line number is returned.

new(Location)

Creates a new collection of annotations given a location.

set_end_location(Location, Anno)

Modifies the end location of the annotations Anno.

set_file(File, Anno)

Modifies the filename of the annotations Anno.

set_generated(Generated, Anno)

Modifies the generated marker of the annotations Anno.

set_line(Line, Anno)

Modifies the line of the annotations Anno.

set_location(Location, Anno)

Modifies the location of the annotations Anno.

set_record(Record, Anno)

Modifies the record marker of the annotations Anno.

set_text(Text, Anno)

Modifies the text of the annotations Anno.

text(Anno)

Returns the text of the annotations Anno. If there is no text, `undefined` is returned.

to_term(Anno)

Returns the term representing the annotations Anno.

## Types

# anno()

(since OTP 18.0)

    -opaque anno()

A collection of annotations.

# anno_term()

(since OTP 18.0)

    -type anno_term() :: term().

The term representing a collection of annotations. It is either a `location/0` or a list of key-value pairs.

# column()

(since OTP 18.0)

    -type column() :: pos_integer().

# filename()

(not exported) (since OTP 18.0)

    -type filename() :: file:filename_all().

# generated()

(not exported) (since OTP 18.0)

    -type generated() :: boolean().

# line()

(since OTP 18.0)

    -nominal line() :: non_neg_integer().

# location()

(since OTP 18.0)

    -nominal location() :: line() | {line(), column()}.

# record_local()

(not exported) (since OTP 18.0)

    -type record_local() :: boolean().

# text()

(since OTP 18.0)

    -type text() :: string().

## Functions

# column(Anno)

(since OTP 18.0)

    -spec column(Anno) -> column() | undefined when Anno :: anno().

Returns the column of the annotations Anno.

# end_location(Anno)

(since OTP 18.0)

    -spec end_location(Anno) -> location() | undefined when Anno :: anno().

Returns the end location of the annotations Anno.

If the end location annotation is present, its value is returned. Otherwise, if the text annotation is present, the end location is inferred from the location and the text. Finally, if there is no text, `undefined` is returned.

# file(Anno)

(since OTP 18.0)

    -spec file(Anno) -> filename() | undefined when Anno :: anno().

Returns the filename of the annotations Anno. If there is no filename, `undefined` is returned.

# from_term(Term)

(since OTP 18.0)

    -spec from_term(Term) -> Anno when Term :: anno_term(), Anno :: anno().

Returns annotations with representation Term.

See also to_term().

# generated(Anno)

(since OTP 18.0)

    -spec generated(Anno) -> generated() when Anno :: anno().

Returns `true` if annotations Anno is marked as generated. The default is to return `false`.

# is_anno(Term)

(since OTP 18.0)

    -spec is_anno(Term) -> boolean() when Term :: any().

Returns `true` if Term is a collection of annotations, otherwise `false`.

# line(Anno)

(since OTP 18.0)

    -spec line(Anno) -> line() when Anno :: anno().

Returns the line of the annotations Anno.

# location(Anno)

(since OTP 18.0)

    -spec location(Anno) -> location() when Anno :: anno().

Returns the location of the annotations Anno. If there is no location, a zero line number is returned.

# new(Location)

(since OTP 18.0)

    -spec new(Location) -> anno() when Location :: location().

Creates a new collection of annotations given a location.

# set_end_location(Location, Anno)

(since OTP 28.0)

    -spec set_end_location(Location, Anno) -> Anno when Location :: location(), Anno :: anno().

Modifies the end location of the annotations Anno.

# set_file(File, Anno)

(since OTP 18.0)

    -spec set_file(File, Anno) -> Anno when File :: filename(), Anno :: anno().

Modifies the filename of the annotations Anno.

# set_generated(Generated, Anno)

(since OTP 18.0)

    -spec set_generated(Generated, Anno) -> Anno when Generated :: generated(), Anno :: anno().

Modifies the generated marker of the annotations Anno.

# set_line(Line, Anno)

(since OTP 18.0)

    -spec set_line(Line, Anno) -> Anno when Line :: line(), Anno :: anno().

Modifies the line of the annotations Anno.

# set_location(Location, Anno)

(since OTP 18.0)

    -spec set_location(Location, Anno) -> Anno when Location :: location(), Anno :: anno().

Modifies the location of the annotations Anno.

# set_record(Record, Anno)

(since OTP 18.0)

    -spec set_record(Record, Anno) -> Anno when Record :: record_local(), Anno :: anno().

Modifies the record marker of the annotations Anno.

# set_text(Text, Anno)

(since OTP 18.0)

    -spec set_text(Text, Anno) -> Anno when Text :: text(), Anno :: anno().

Modifies the text of the annotations Anno.

# text(Anno)

(since OTP 18.0)

    -spec text(Anno) -> text() | undefined when Anno :: anno().

Returns the text of the annotations Anno. If there is no text, `undefined` is returned.

# to_term(Anno)

(since OTP 18.0)

    -spec to_term(Anno) -> anno_term() when Anno :: anno().

Returns the term representing the annotations Anno.

See also from_term().